/*
  
  

			CADRE TRANSFORM
  
  
*/


/*
  				       Dbut de package							
  */
package 
{
	/*
	  				           IMPORT							 	
	  */
	import flash.display.MovieClip;
	import flash.events.Event;
	import flash.text.TextFormat
	import flash.display.DisplayObject
	import flash.events.MouseEvent
	import flash.geom.Rectangle
	import flash.geom.Point
	import flash.text.AntiAliasType 
	import flash.text.TextField 	
	import flash.text.TextFieldAutoSize
	import flash.display.Stage
	//import softpeople.NewObjetCourant

	
	public dynamic class CadreTransform extends MovieClip
	{
		
		//private var isScaling:Boolean =false
		//private var isRotating:Boolean =false
		private var prevMouse:Point = new Point (0,0)
		private var curMouse:Point = new Point (0,0)
		
		var dirRotate:int=0
		private var curSquare:MovieClip
		private var stepMouse:int = 0
		private var curAngle:Number = 0
		private var cible:MovieClip
		private var Ocourant:MovieClip
		private var tempDraginClip:MovieClip  
		private var isDragin:Boolean = false
		//private var zoneImprimable:MovieClip
		private var delimitCenter:Point = new Point (0,0) // center Point of delimit 
		private static var _parent     		:MovieClip; 
		private static var _targCenter     	:Point;  
		private static var _radius         	:Number; // max dist from center of _target to the corners //
		// min and max scale amounts //	
		private static var _minScale       	:Number = .2;
		/*
							      INITIALISATION 						
		*/
		public function CadreTransform()
		{
			
			
			stage.addEventListener (MouseEvent.MOUSE_UP, _onMouseUp)
			stage.addEventListener (MouseEvent.MOUSE_DOWN, _onMouseDown)
			
			delimit.addEventListener (MouseEvent.MOUSE_DOWN, _startDrag)
			
			delimit.buttonMode = true
			
			// BTN DELETE
			btn_delete.buttonMode = true
			btn_delete.addEventListener (MouseEvent.CLICK, deleteOcourant)
			
			// SET 4 scale SQUARES AT EACH CORNER
			for (var iX:int=0;iX<2;iX++)
			{
				for (var iY:int=0;iY<2;iY++)
				{
					curSquare	= new CadreTransformCarreNoir ()
					curSquare.x = delimit.x+delimit.width*iX
					curSquare.y = delimit.y+delimit.height*iY
					curSquare.coordinates = new Point (iX,iY)
					curSquare.name = String(iX)+String(iY)
					addChild(curSquare)
					curSquare.buttonMode = true
					curSquare.addEventListener (MouseEvent.MOUSE_DOWN, scaleOcourant)
				}
			}
			
			
			// ROTATE
			btn_rotate.buttonMode = true
			btn_rotate.addEventListener (MouseEvent.MOUSE_DOWN, rotateOcourant)
			delimitCenter.x = delimit.x; delimitCenter.y = delimit.y 
			 setPositions ()
			
		}
		
		public function setNewOcourant(pOcourant:MovieClip)
		{
			trace("setNewOcourant", pOcourant, pOcourant.getRect(parent))
			Ocourant = pOcourant
			_parent = MovieClip(Ocourant.parent)
			delimit.width = Ocourant.width
			delimit.height = Ocourant.height
			delimit.x = delimit.y = 0
			this.x = Ocourant.x
			this.y = Ocourant.y
			this.visible = true
			 setPositions ()	
		}
		
		/*
							      PARTIE SCALE				
		*/
		private function scaleOcourant(e)
		{
			trace("transformOcourant")
			_radius =  Math.sqrt(delimit.width * delimit.width + delimit.height * delimit.height) / 2
			delimitCenter.x = delimit.x; delimitCenter.y = delimit.y 
			//curSquare = e.target
			stage.addEventListener (MouseEvent.MOUSE_MOVE, onMouseMove_Scale)
		}
		
		private function onMouseMove_Scale(e)
		{
				cible = delimit
			
				Ocourant.width  = Point.distance(new Point(mouseX, mouseY), delimitCenter)*2
				Ocourant.scaleY = Ocourant.scaleX
				if (Ocourant.scaleX < _minScale)
					Ocourant.scaleX  = Ocourant.scaleY = _minScale;
		
				cible.width = Ocourant.width
				cible.height = Ocourant.height
				
				setPositions ()			
			
				// BTN ROTATE
				btn_rotate.x=delimit.x
		}
		
		
		/*
							      PARTIE ROTATE				
		*/
		private function rotateOcourant (e)
		{
	
			delimitCenter.x = delimit.x; delimitCenter.y = delimit.y 
			curAngle = Ocourant.rotation
	
			stage.addEventListener (MouseEvent.MOUSE_MOVE, onMouseMove_Rotate)
		}
		
		private function onMouseMove_Rotate(e)
		{

			curMouse.x = this.mouseX;
			curMouse.y = this.mouseY;
			
			var angleMouseCentre:Number = angleEntresDeuxPoints(delimitCenter, curMouse)
			btn_rotate.rotation = Ocourant.rotation = curAngle + angleMouseCentre//dirRotate*1
			setPositions ()
		}
		
		private function angleEntresDeuxPoints(origine:Point,arrivee:Point):Number
		{
			/*	Mouse
				 /
				/_)_ angle
			Origine 		*/
			var arrivee2:Point = new Point(arrivee.x - origine.x, arrivee.y - origine.y);
			var hauteur:int = arrivee.y - origine.y
			var base:int= int(arrivee.x - origine.x)

			var radians:Number = Math.atan(hauteur/base)
			var degrees:Number = 2 * radians / (Math.PI / 180)
			degrees+=180
			//trace (degrees)
			return degrees;
		}
		/*
							      PARTIE DRAG				
		*/
		private function _startDrag (e)
		{
			trace ("_startDrag")
			tempDraginClip  = new MovieClip ()
			isDragin = true
			//trace ("parent.tempDraginClip",parent.tempDraginClip)
			_parent.addChild(tempDraginClip)
			tempDraginClip.addChild(Ocourant)
			tempDraginClip.addChild(this)	
			tempDraginClip.startDrag(false)
		}
		
		function _stopDrag()
		{
			trace ("_stopDrag",isDragin)
			if (!isDragin) return
			isDragin = false
			if (Ocourant) _parent.addChild(Ocourant)
			_parent.addChild(this)
			
			tempDraginClip.stopDrag()
			//this.x = Ocourant.x += tempDraginClip.x
			//this.y = Ocourant.y += tempDraginClip.y
			Ocourant.x += tempDraginClip.x
			Ocourant.y += tempDraginClip.y
			this.x += tempDraginClip.x
			this.y += tempDraginClip.y
			
			_parent.removeChild(tempDraginClip)
			tempDraginClip=null
			
			
			
		}
		/*
							      PARTIE COMMUNE				
		*/
		
		private function _onMouseUp(e)
		{
			
			stage.removeEventListener (MouseEvent.MOUSE_MOVE, onMouseMove_Scale)
			stage.removeEventListener (MouseEvent.MOUSE_MOVE, onMouseMove_Rotate)
			_stopDrag()
			//trace("_onMouseUp", e.target)
			//if (e.target != this ) this.visible = false 
		}
		
		private function _onMouseDown(e)
		{
			trace ("_onMouseDown",e.target)
			if (e.target is Stage) this.visible = false
		}
		
		private function deleteOcourant(e)
		{
			dispatchEvent (new Event("deleteOcourant"))
			parent.removeChild(Ocourant)
			Ocourant = null
			this.visible = false
		}
			
		private function setPositions ()
		{
			if (Ocourant)
			{
			var boundingBox:Rectangle = Ocourant.getBounds(parent)
			delimit.width = boundingBox.width
			delimit.height = boundingBox.height
			
			}
			
			// SET 4 scale SQUARES AT EACH CORNER
			for (var iX:int=0;iX<2;iX++)
			{
				for (var iY:int=0;iY<2;iY++)
				{
					curSquare = MovieClip (getChildByName ( String(iX)+String(iY)))
					curSquare.x = delimit.x+delimit.width*iX-delimit.width/2
					curSquare.y = delimit.y+delimit.height*iY-delimit.height/2
					curSquare.coordinates = new Point (iX,iY)
				}
			}
			
			// BTN ROTATE
			btn_rotate.x = delimit.x
			btn_rotate.y = delimit.y - delimit.height / 2 -10
			
			// BTN DELETE
			btn_delete.x = delimit.x
			btn_delete.y = delimit.y + delimit.height/2+3 +btn_delete.height/2
		}
		
	}
}